=== modified file 'NEWS'
--- NEWS	2010-05-06 07:48:22 +0000
+++ NEWS	2010-04-29 05:52:35 +0000
@@ -16,10 +16,6 @@
 New Features
 ************
 
-* ``bzr commit`` accepts ``-p`` (for "patch") as a shorter name for
-  ``--show-diff``.
-  (Parth Malwankar, #571467)
-  
 * ``bzr ignore`` now supports a ``--default-rules`` option that displays
   the default ignore rules used by bzr. The flag ``--old-default-rules``
   is no longer supported by ``ignore``.
@@ -52,10 +48,6 @@
 * Don't mention --no-strict when we just issue the warning about unclean trees.
   (Vincent Ladeuil, #401599)
 
-* Fixed ``AssertionError`` when accessing smart servers running Bazaar
-  versions before 1.6.
-  (Andrew Bennetts, #528041)
-
 * Reduce peak memory by one copy of compressed text.
   (John Arbash Meinel, #566940)
 
@@ -99,13 +91,6 @@
 Internals
 *********
 
-* ``_remember_remote_is_before`` no longer raises AssertionError when
-  suboptimal network behaviour is noticed; instead it just mutters to the
-  log file (and warns the user if they have set the ``hpss`` debug flag).
-  This was causing unnecessary aborts for performance bugs that are minor
-  at worst.
-  (Andrew Bennetts, #528041)
-
 * Permit bzr to run under ``python -OO`` which reduces the size of bytecode
   files loaded from disk. To ensure docstrings needed for help are never
   stripped, the prefix ``__doc__ =`` should now be used.
@@ -114,10 +99,6 @@
 Testing
 *******
 
-* Added ``bzrlib.tests.matchers`` as a place to put matchers, along with
-  our first in-tree matcher. See the module docstring for details.
-  (Robert Collins)
-
 * ``bzr selftest --parallel=subprocess`` now works correctly on win32.
    (Gordon Tyler, #551332)
 
@@ -192,9 +173,6 @@
   -rX..Y.
   (Vincent Ladeuil, #474807)
 
-* Properly handle ``param_name`` attribute for ``ListOption``.
-  (Martin von Gagern, 387117)
-
 Improvements
 ************
 
@@ -527,38 +505,6 @@
   happens, and another warning will be written if the log file could not
   be closed after retrying 100 times.  (Andrew Bennetts, #531746)
 
-bzr 2.1.2
-#########
-
-:2.1.2: NOT RELEASED YET
-
-Bug Fixes
-*********
-
-* ``bzr switch`` does not die if a ConfigurableFileMerger is used.
-  (Aaron Bentley, #559436)
-
-* Fixed ``AssertionError`` when accessing smart servers running Bazaar
-  versions before 1.6.
-  (Andrew Bennetts, #528041)
-
-* Reset ``siginterrupt`` flag to False every time we handle a signal
-  installed with ``set_signal_handler(..., restart_syscall=True)`` (from
-  ``bzrlib.osutils``.  Reduces the likelihood of "Interrupted System Call"
-  errors after two window resizes.
-  (Andrew Bennetts)
-
-Internals
-*********
-
-* ``_remember_remote_is_before`` no longer raises AssertionError when
-  suboptimal network behaviour is noticed; instead it just mutters to the
-  log file (and warns the user if they have set the ``hpss`` debug flag).
-  This was causing unnecessary aborts for performance bugs that are minor
-  at worst.
-  (Andrew Bennetts, #528041)
-
-
 bzr 2.1.1
 #########
 
@@ -592,12 +538,6 @@
   problems importing bzrlib from a non-main thread.
   (Elliot Murphy, #521989)
 
-* Repositories accessed via a smart server now reject being stacked on a
-  repository in an incompatible format, as is the case when accessing them
-  via other methods.  This was causing fetches from those repositories via
-  a smart server (e.g. using ``bzr branch``) to receive invalid data.
-  (Andrew Bennetts, #562380)
-
 * Standardize the error handling when creating a new ``StaticTuple``
   (problems will raise TypeError). (Matt Nordhoff, #457979)
 

=== modified file 'bzrlib/_readdir_py.py'
--- bzrlib/_readdir_py.py	2010-04-30 11:03:59 +0000
+++ bzrlib/_readdir_py.py	2009-03-23 14:59:43 +0000
@@ -17,6 +17,7 @@
 """Python implementation of readdir interface."""
 
 
+import os
 import stat
 
 

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2010-04-30 11:03:59 +0000
+++ bzrlib/add.py	2009-04-04 02:50:01 +0000
@@ -16,11 +16,15 @@
 
 """Helper functions for adding files to working trees."""
 
+import errno
+import os
 import sys
 
 import bzrlib.bzrdir
+import bzrlib.errors as errors
 import bzrlib.osutils
 from bzrlib.symbol_versioning import *
+from bzrlib.workingtree import WorkingTree
 
 
 class AddAction(object):

=== modified file 'bzrlib/atomicfile.py'
--- bzrlib/atomicfile.py	2010-04-30 11:03:59 +0000
+++ bzrlib/atomicfile.py	2010-03-10 13:25:36 +0000
@@ -16,6 +16,7 @@
 
 
 import os
+import sys
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """

=== modified file 'bzrlib/bugtracker.py'
--- bzrlib/bugtracker.py	2010-04-30 11:03:59 +0000
+++ bzrlib/bugtracker.py	2010-02-17 17:11:16 +0000
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from bzrlib import registry
+from bzrlib import registry, help_topics
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from bzrlib import errors, urlutils

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2010-05-03 09:07:50 +0000
+++ bzrlib/builtins.py	2010-04-28 10:33:44 +0000
@@ -3073,7 +3073,7 @@
                          "the master branch until a normal commit "
                          "is performed."
                     ),
-             Option('show-diff', short_name='p',
+             Option('show-diff',
                     help='When no message is supplied, show the diff along'
                     ' with the status summary in the message editor.'),
              ]
@@ -4681,7 +4681,6 @@
 
 class cmd_bind(Command):
     __doc__ = """Convert the current branch into a checkout of the supplied branch.
-    If no branch is supplied, rebind to the last bound location.
 
     Once converted into a checkout, commits must succeed on the master branch
     before they will be applied to the local branch.

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2010-04-30 11:35:43 +0000
+++ bzrlib/check.py	2010-04-23 00:44:15 +0000
@@ -46,9 +46,13 @@
   indicating that the revision was found/not found.
 """
 
-from bzrlib import errors
+from bzrlib import errors, osutils
+from bzrlib import repository as _mod_repository
+from bzrlib import revision
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import BzrDir
+from bzrlib.errors import BzrCheckError
+from bzrlib.repository import Repository
 from bzrlib.revision import NULL_REVISION
 from bzrlib.symbol_versioning import deprecated_function, deprecated_in
 from bzrlib.trace import note

=== modified file 'bzrlib/clean_tree.py'
--- bzrlib/clean_tree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/clean_tree.py	2009-03-23 14:59:43 +0000
@@ -15,10 +15,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
+import errno
 import os
 import shutil
+import sys
 
-from bzrlib.osutils import isdir
+from bzrlib.osutils import has_symlinks, isdir
 from bzrlib.trace import note
 from bzrlib.workingtree import WorkingTree
 

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2010-04-30 11:35:43 +0000
+++ bzrlib/commit.py	2010-04-10 09:22:04 +0000
@@ -49,12 +49,20 @@
 # TODO: Change the parameter 'rev_id' to 'revision_id' to be consistent with
 # the rest of the code; add a deprecation of the old name.
 
+import os
+import re
+import sys
+import time
+
+from cStringIO import StringIO
+
 from bzrlib import (
     debug,
     errors,
     revision,
     trace,
     tree,
+    xml_serializer,
     )
 from bzrlib.branch import Branch
 from bzrlib.cleanup import OperationWithCleanups
@@ -64,13 +72,20 @@
                            StrictCommitFailed
                            )
 from bzrlib.osutils import (get_user_encoding,
-                            is_inside_any,
+                            kind_marker, isdir,isfile, is_inside_any,
+                            is_inside_or_parent_of_any,
                             minimum_path_selection,
+                            quotefn, sha_file, split_lines,
                             splitpath,
                             )
-from bzrlib.trace import mutter, note, is_quiet
+from bzrlib.testament import Testament
+from bzrlib.trace import mutter, note, warning, is_quiet
 from bzrlib.inventory import Inventory, InventoryEntry, make_entry
 from bzrlib import symbol_versioning
+from bzrlib.symbol_versioning import (deprecated_passed,
+        deprecated_function,
+        DEPRECATED_PARAMETER)
+from bzrlib.workingtree import WorkingTree
 from bzrlib.urlutils import unescape_for_display
 import bzrlib.ui
 

=== modified file 'bzrlib/conflicts.py'
--- bzrlib/conflicts.py	2010-04-30 11:35:43 +0000
+++ bzrlib/conflicts.py	2010-04-02 19:12:58 +0000
@@ -18,6 +18,7 @@
 # point down
 
 import os
+import re
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """

=== modified file 'bzrlib/delta.py'
--- bzrlib/delta.py	2010-04-30 11:35:43 +0000
+++ bzrlib/delta.py	2010-03-19 23:58:06 +0000
@@ -15,9 +15,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 from bzrlib import (
+    errors,
     osutils,
     )
-from bzrlib.trace import is_quiet
+from bzrlib.inventory import InventoryEntry
+from bzrlib.trace import mutter, is_quiet
+from bzrlib.symbol_versioning import deprecated_function
 
 
 class TreeDelta(object):

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2010-04-30 11:35:43 +0000
+++ bzrlib/diff.py	2010-04-19 04:10:53 +0000
@@ -17,6 +17,7 @@
 import difflib
 import os
 import re
+import shutil
 import string
 import sys
 

=== added directory 'bzrlib/doc_generate/builders'
=== added file 'bzrlib/doc_generate/builders/__init__.py'
--- bzrlib/doc_generate/builders/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/doc_generate/builders/__init__.py	2010-04-29 15:41:20 +0000
@@ -0,0 +1,1 @@
+

=== added file 'bzrlib/doc_generate/builders/texinfo.py'
--- bzrlib/doc_generate/builders/texinfo.py	1970-01-01 00:00:00 +0000
+++ bzrlib/doc_generate/builders/texinfo.py	2010-04-28 17:11:50 +0000
@@ -0,0 +1,36 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""A sphinx builder producing texinfo output."""
+
+from sphinx import builders
+from sphinx.builders import text as _text_builder
+
+from bzrlib.doc_generate.writers import texinfo as texinfo_writer
+
+class TexinfoBuilder(_text_builder.TextBuilder):
+
+    name = 'texinfo'
+    format = 'texinfo'
+    out_suffix = '.texi'
+
+
+    def prepare_writing(self, docnames):
+        self.writer = texinfo_writer.TexinfoWriter(self)
+
+
+def setup(app):
+    app.add_builder(TexinfoBuilder)

=== modified file 'bzrlib/doc_generate/sphinx_conf.py'
--- bzrlib/doc_generate/sphinx_conf.py	2009-09-08 16:37:05 +0000
+++ bzrlib/doc_generate/sphinx_conf.py	2010-04-29 15:41:20 +0000
@@ -8,6 +8,9 @@
 
 import sys, os
 
+# FIXME: better move the content of doc/en/conf.py here and cleanup the result
+# -- vila 20100428
+
 # If extensions (or modules to document with autodoc) are in another directory,
 # add these directories to sys.path here. If the directory is relative to the
 # documentation root, use os.path.abspath to make it absolute, like shown here.
@@ -18,7 +21,8 @@
 
 # Add any Sphinx extension module names here, as strings. They can be extensions
 # coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = ['sphinx.ext.ifconfig']
+extensions = ['sphinx.ext.ifconfig',
+              'bzrlib.doc_generate.builders.texinfo']
 
 # Add any paths that contain templates here, relative to this directory.
 templates_path = ['_templates']
@@ -34,7 +38,7 @@
 
 # General information about the project.
 project = u'Bazaar'
-copyright = u'2009, Canonical Ltd'
+copyright = u'2010, Canonical Ltd'
 
 # The version info for the project you're documenting, acts as replacement for
 # |version| and |release|, also used in various other places throughout the

=== added directory 'bzrlib/doc_generate/writers'
=== added file 'bzrlib/doc_generate/writers/__init__.py'
--- bzrlib/doc_generate/writers/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/doc_generate/writers/__init__.py	2010-04-29 15:41:20 +0000
@@ -0,0 +1,1 @@
+

=== added file 'bzrlib/doc_generate/writers/texinfo.py'
--- bzrlib/doc_generate/writers/texinfo.py	1970-01-01 00:00:00 +0000
+++ bzrlib/doc_generate/writers/texinfo.py	2010-04-28 17:11:50 +0000
@@ -0,0 +1,27 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""A sphinx/docutil writer producing texinfo output."""
+
+from docutils import nodes, writers
+
+
+# class TexinfoWriter(writers.Writer):
+
+from sphinx.writers import text
+
+TexinfoWriter = text.TextWriter
+

=== modified file 'bzrlib/externalcommand.py'
--- bzrlib/externalcommand.py	2010-04-30 11:03:59 +0000
+++ bzrlib/externalcommand.py	2009-03-23 14:59:43 +0000
@@ -20,8 +20,10 @@
 
 
 import os
+import sys
 
 from bzrlib.commands import Command
+from bzrlib.osutils import pathjoin
 
 
 class ExternalCommand(Command):

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2010-04-30 11:35:43 +0000
+++ bzrlib/fetch.py	2010-03-21 21:39:33 +0000
@@ -35,6 +35,7 @@
 import bzrlib
 from bzrlib import (
     errors,
+    symbol_versioning,
     ui,
     )
 from bzrlib.revision import NULL_REVISION

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2010-04-30 11:03:59 +0000
+++ bzrlib/help.py	2010-02-17 17:11:16 +0000
@@ -30,6 +30,7 @@
     help_topics,
     osutils,
     plugin,
+    symbol_versioning,
     )
 
 

=== modified file 'bzrlib/help_topics/en/conflict-types.txt'
--- bzrlib/help_topics/en/conflict-types.txt	2010-02-04 13:29:34 +0000
+++ bzrlib/help_topics/en/conflict-types.txt	2010-04-28 13:15:14 +0000
@@ -28,11 +28,11 @@
 
 Whatever the conflict is, resolving it is roughly done in two steps::
 
-- modify the working tree content so that the conflicted item is now in the
-  state you want to keep,
+ - modify the working tree content so that the conflicted item is now in the
+   state you want to keep,
 
-- inform Bazaar that the conflict is now solved and ask to cleanup any
-  remaining generated information (``bzr resolve <item>``).
+ - inform Bazaar that the conflict is now solved and ask to cleanup any
+   remaining generated information (``bzr resolve <item>``).
 
 For most conflict types, there are some obvious ways to modify the working
 tree and put it into the desired state. For some types of conflicts, Bazaar
@@ -126,9 +126,9 @@
 
 ``bzr resolve`` recognizes the following actions:
 
-- ``--action=take-this`` will issue ``bzr mv FILE.THIS FILE``,
-- ``--action=take-other`` will issue ``bzr mv FILE.OTHER FILE``,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will issue ``bzr mv FILE.THIS FILE``,
+ - ``--action=take-other`` will issue ``bzr mv FILE.OTHER FILE``,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Any action will also delete the previously generated ``.BASE``, ``.THIS`` and
 ``.OTHER`` files if they are still present in the working tree.
@@ -174,9 +174,9 @@
 
 ``bzr resolve`` recognizes the following actions::
 
-- ``--action=take-this`` will issue ``bzr rm FILE ; bzr mv FILE.moved FILE``,
-- ``--action=take-other`` will issue ``bzr rm FILE.moved``,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will issue ``bzr rm FILE ; bzr mv FILE.moved FILE``,
+ - ``--action=take-other`` will issue ``bzr rm FILE.moved``,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Note that you must get rid of FILE.moved before using ``--action=done``.
 
@@ -215,10 +215,11 @@
 
 ``bzr resolve`` recognizes the following actions::
 
-- ``--action=take-this`` will issue ``bzr rm directory`` including the children,
-- ``--action=take-other`` will acknowledge Bazaar choice to keep the children
-  and restoring the directory,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will issue ``bzr rm directory`` including the
+   children,
+ - ``--action=take-other`` will acknowledge Bazaar choice to keep the children
+   and restoring the directory,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Bazaar cannot auto-detect when conflicts of this kind have been resolved.
 
@@ -238,10 +239,10 @@
 
 ``bzr resolve`` recognizes the following actions::
 
-- ``--action=take-this`` will acknowledge Bazaar choice to keep the directory,
-- ``--action=take-other`` will issue ``bzr rm directory`` including the 
-  children,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will acknowledge Bazaar choice to keep the directory,
+ - ``--action=take-other`` will issue ``bzr rm directory`` including the 
+   children,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Bazaar cannot auto-detect when conflicts of this kind have been resolved.
 
@@ -260,10 +261,10 @@
 
 ``bzr resolve`` recognizes the following actions::
 
-- ``--action=take-this`` will revert Bazaar choice and keep ``PATH1`` by
-  issuing ``bzr mv PATH2 PATH1``,
-- ``--action=take-other`` will acknowledge Bazaar choice of keeping ``PATH2``,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will revert Bazaar choice and keep ``PATH1`` by
+   issuing ``bzr mv PATH2 PATH1``,
+ - ``--action=take-other`` will acknowledge Bazaar choice of keeping ``PATH2``,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Bazaar cannot auto-detect when conflicts of this kind have been resolved.
 
@@ -295,11 +296,11 @@
 
 ``bzr resolve`` recognizes the following actions::
 
-- ``--action=take-this`` will acknowledge Bazaar choice of leaving ``white`` 
-  in ``black``,
-- ``--action=take-other`` will revert Bazaar choice and move ``black`` in
-  ``white`` by issuing ``bzr mv black/white white ; bzr mv black white``,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will acknowledge Bazaar choice of leaving ``white`` 
+   in ``black``,
+ - ``--action=take-other`` will revert Bazaar choice and move ``black`` in
+   ``white`` by issuing ``bzr mv black/white white ; bzr mv black white``,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Bazaar cannot auto-detect when conflicts of this kind have been resolved.
 
@@ -330,11 +331,11 @@
 
 ``bzr resolve`` recognizes the following actions::
 
-- ``--action=take-this`` will issue ``bzr rm --force foo.new`` and 
-  ``bzr add foo``,
-- ``--action=take-other`` will issue ``bzr rm --force foo`` and 
-  ``bzr mv foo.new foo``,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will issue ``bzr rm --force foo.new`` and 
+   ``bzr add foo``,
+ - ``--action=take-other`` will issue ``bzr rm --force foo`` and 
+   ``bzr mv foo.new foo``,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Bazaar cannot auto-detect when conflicts of this kind have been resolved.
 

=== modified file 'bzrlib/hooks.py'
--- bzrlib/hooks.py	2010-04-30 11:03:59 +0000
+++ bzrlib/hooks.py	2010-03-12 19:59:50 +0000
@@ -18,6 +18,7 @@
 """Support for plugin hooking logic."""
 from bzrlib import registry
 from bzrlib.lazy_import import lazy_import
+from bzrlib.symbol_versioning import deprecated_method
 lazy_import(globals(), """
 import textwrap
 

=== modified file 'bzrlib/identitymap.py'
--- bzrlib/identitymap.py	2010-04-30 11:03:59 +0000
+++ bzrlib/identitymap.py	2009-03-23 14:59:43 +0000
@@ -20,6 +20,7 @@
 
 from bzrlib import (
     errors,
+    osutils,
     )
 
 

=== modified file 'bzrlib/ignores.py'
--- bzrlib/ignores.py	2010-04-30 07:54:33 +0000
+++ bzrlib/ignores.py	2010-04-26 13:51:08 +0000
@@ -176,11 +176,10 @@
 
 
 def tree_ignores_add_patterns(tree, name_pattern_list):
-    """Add more ignore patterns to the ignore file in a tree.
-    If ignore file does not exist then it will be created.
-    The ignore file will be automatically added under version control.
+    """Retrieve a list of ignores from the ignore file in a tree.
 
-    :param tree: Working tree to update the ignore list.
+    :param tree: Tree to retrieve the ignore list from.
+    :return:
     """
     ifn = tree.abspath(bzrlib.IGNORE_FILENAME)
     if tree.has_filename(ifn):
@@ -207,5 +206,5 @@
     finally:
         f.close()
 
-    if not tree.path2id(bzrlib.IGNORE_FILENAME):
-        tree.add([bzrlib.IGNORE_FILENAME])
+    if not tree.path2id('.bzrignore'):
+        tree.add(['.bzrignore'])

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2010-04-30 11:35:43 +0000
+++ bzrlib/info.py	2010-04-21 09:57:18 +0000
@@ -17,11 +17,13 @@
 __all__ = ['show_bzrdir_info']
 
 from cStringIO import StringIO
+import os
 import time
 import sys
 
 from bzrlib import (
     bzrdir,
+    diff,
     errors,
     hooks as _mod_hooks,
     osutils,

=== modified file 'bzrlib/lockable_files.py'
--- bzrlib/lockable_files.py	2010-04-30 11:03:59 +0000
+++ bzrlib/lockable_files.py	2009-10-15 02:11:18 +0000
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from cStringIO import StringIO
+
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 import codecs
@@ -32,6 +34,10 @@
 from bzrlib.decorators import (
     only_raises,
     )
+from bzrlib.symbol_versioning import (
+    deprecated_in,
+    deprecated_method,
+    )
 
 
 # XXX: The tracking here of lock counts and whether the lock is held is

=== modified file 'bzrlib/memorytree.py'
--- bzrlib/memorytree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/memorytree.py	2009-04-09 20:23:07 +0000
@@ -25,9 +25,10 @@
 from bzrlib import (
     errors,
     mutabletree,
+    osutils,
     revision as _mod_revision,
     )
-from bzrlib.decorators import needs_read_lock
+from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.osutils import sha_file
 from bzrlib.mutabletree import needs_tree_write_lock
 from bzrlib.transport.memory import MemoryTransport

=== modified file 'bzrlib/missing.py'
--- bzrlib/missing.py	2010-04-30 11:03:59 +0000
+++ bzrlib/missing.py	2009-08-17 18:52:01 +0000
@@ -18,6 +18,8 @@
 
 from bzrlib import (
     log,
+    repository as _mod_repository,
+    tsort,
     )
 import bzrlib.revision as _mod_revision
 

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2010-04-30 11:35:43 +0000
+++ bzrlib/msgeditor.py	2010-04-07 22:22:27 +0000
@@ -18,6 +18,7 @@
 """Commit message editor support."""
 
 import codecs
+import errno
 import os
 from subprocess import call
 import sys

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2010-04-20 08:47:38 +0000
+++ bzrlib/option.py	2010-04-13 04:33:55 +0000
@@ -276,7 +276,7 @@
         parser.add_option(action='callback',
                           callback=self._optparse_callback,
                           type='string', metavar=self.argname.upper(),
-                          help=self.help, dest=self._param_name, default=[],
+                          help=self.help, default=[],
                           *option_strings)
 
     def _optparse_callback(self, option, opt, value, parser):

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2010-05-03 06:25:46 +0000
+++ bzrlib/osutils.py	2010-04-27 07:52:08 +0000
@@ -17,10 +17,12 @@
 import os
 import re
 import stat
-from stat import S_ISREG, S_ISDIR, S_ISLNK, ST_MODE, ST_SIZE
+from stat import (S_ISREG, S_ISDIR, S_ISLNK, ST_MODE, ST_SIZE,
+                  S_ISCHR, S_ISBLK, S_ISFIFO, S_ISSOCK)
 import sys
 import time
 import codecs
+import warnings
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -1147,7 +1149,7 @@
 
 
 def relpath(base, path):
-    """Return path relative to base, or raise PathNotChild exception.
+    """Return path relative to base, or raise exception.
 
     The path may be either an absolute path or a path relative to the
     current working directory.
@@ -1155,9 +1157,6 @@
     os.path.commonprefix (python2.4) has a bad bug that it works just
     on string prefixes, assuming that '/u' is a prefix of '/u2'.  This
     avoids that problem.
-
-    NOTE: `base` should not have a trailing slash otherwise you'll get
-    PathNotChild exceptions regardless of `path`.
     """
 
     if len(base) < MIN_ABS_PATHLENGTH:

=== modified file 'bzrlib/plugins/launchpad/lp_directory.py'
--- bzrlib/plugins/launchpad/lp_directory.py	2010-03-30 11:05:14 +0000
+++ bzrlib/plugins/launchpad/lp_directory.py	2010-02-17 17:11:16 +0000
@@ -17,13 +17,14 @@
 
 """Directory lookup that uses Launchpad."""
 
-from urlparse import urlsplit
+from urlparse import urlsplit, urlunsplit
 import xmlrpclib
 
 from bzrlib import (
     debug,
     errors,
     trace,
+    urlutils,
     )
 from bzrlib.transport import (
     get_transport,

=== modified file 'bzrlib/plugins/news_merge/__init__.py'
--- bzrlib/plugins/news_merge/__init__.py	2010-05-03 04:08:50 +0000
+++ bzrlib/plugins/news_merge/__init__.py	2010-04-16 12:59:03 +0000
@@ -21,6 +21,7 @@
 
     [/home/user/code/bzr]
     news_merge_files = NEWS
+    news_merge_files:policy = recurse
 
 The news_merge_files config option takes a list of file paths, separated by
 commas.

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2010-04-30 11:03:59 +0000
+++ bzrlib/progress.py	2010-02-25 06:42:33 +0000
@@ -27,7 +27,12 @@
 import os
 
 
+from bzrlib import (
+    errors,
+    )
+from bzrlib.trace import mutter
 from bzrlib.symbol_versioning import (
+    deprecated_function,
     deprecated_in,
     deprecated_method,
     )

=== modified file 'bzrlib/push.py'
--- bzrlib/push.py	2010-04-30 11:03:59 +0000
+++ bzrlib/push.py	2010-02-16 16:08:40 +0000
@@ -17,6 +17,8 @@
 """UI helper for the push command."""
 
 from bzrlib import (
+    builtins,
+    branch,
     bzrdir,
     errors,
     revision as _mod_revision,

=== modified file 'bzrlib/reconcile.py'
--- bzrlib/reconcile.py	2010-04-30 11:35:43 +0000
+++ bzrlib/reconcile.py	2010-04-23 00:44:15 +0000
@@ -30,6 +30,7 @@
     cleanup,
     errors,
     ui,
+    repository,
     )
 from bzrlib.trace import mutter
 from bzrlib.tsort import topo_sort

=== modified file 'bzrlib/revisiontree.py'
--- bzrlib/revisiontree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/revisiontree.py	2010-02-17 17:11:16 +0000
@@ -20,7 +20,9 @@
 
 from bzrlib import (
     errors,
+    osutils,
     revision,
+    symbol_versioning,
     tree,
     )
 

=== modified file 'bzrlib/shelf.py'
--- bzrlib/shelf.py	2010-04-30 11:03:59 +0000
+++ bzrlib/shelf.py	2009-09-11 07:55:48 +0000
@@ -23,8 +23,11 @@
     errors,
     merge,
     merge3,
+    osutils,
     pack,
     transform,
+    ui,
+    workingtree,
 )
 
 

=== modified file 'bzrlib/smart/medium.py'
--- bzrlib/smart/medium.py	2010-05-03 04:08:50 +0000
+++ bzrlib/smart/medium.py	2010-03-18 23:11:15 +0000
@@ -607,16 +607,10 @@
             # which is newer than a previously supplied older-than version.
             # This indicates that some smart verb call is not guarded
             # appropriately (it should simply not have been tried).
-            trace.mutter(
+            raise AssertionError(
                 "_remember_remote_is_before(%r) called, but "
                 "_remember_remote_is_before(%r) was called previously."
-                , version_tuple, self._remote_version_is_before)
-            if 'hpss' in debug.debug_flags:
-                ui.ui_factory.show_warning(
-                    "_remember_remote_is_before(%r) called, but "
-                    "_remember_remote_is_before(%r) was called previously."
-                    % (version_tuple, self._remote_version_is_before))
-            return
+                % (version_tuple, self._remote_version_is_before))
         self._remote_version_is_before = version_tuple
 
     def protocol_version(self):

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2010-04-30 11:35:43 +0000
+++ bzrlib/status.py	2010-04-15 20:22:04 +0000
@@ -20,10 +20,14 @@
     delta as _mod_delta,
     log,
     osutils,
+    tree,
     tsort,
     revision as _mod_revision,
     )
 import bzrlib.errors as errors
+from bzrlib.osutils import is_inside_any
+from bzrlib.symbol_versioning import (deprecated_function,
+        )
 from bzrlib.trace import mutter, warning
 
 # TODO: when showing single-line logs, truncate to the width of the terminal

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2010-05-06 07:48:22 +0000
+++ bzrlib/tests/__init__.py	2010-04-29 15:41:20 +0000
@@ -3632,6 +3632,7 @@
         'bzrlib.doc',
         'bzrlib.tests.blackbox',
         'bzrlib.tests.commands',
+        'bzrlib.tests.doc_generate',
         'bzrlib.tests.per_branch',
         'bzrlib.tests.per_bzrdir',
         'bzrlib.tests.per_bzrdir_colo',
@@ -3734,7 +3735,6 @@
         'bzrlib.tests.test_lru_cache',
         'bzrlib.tests.test_lsprof',
         'bzrlib.tests.test_mail_client',
-        'bzrlib.tests.test_matchers',
         'bzrlib.tests.test_memorytree',
         'bzrlib.tests.test_merge',
         'bzrlib.tests.test_merge3',

=== added directory 'bzrlib/tests/doc_generate'
=== added file 'bzrlib/tests/doc_generate/__init__.py'
--- bzrlib/tests/doc_generate/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/doc_generate/__init__.py	2010-04-29 15:41:20 +0000
@@ -0,0 +1,32 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Documentation generation tests."""
+
+def load_tests(basic_tests, module, loader):
+    suite = loader.suiteClass()
+    # add the tests for this module
+    suite.addTests(basic_tests)
+
+    testmod_names = [
+        'builders',
+        ]
+    # add the tests for the sub modules
+    suite.addTests(loader.loadTestsFromModuleNames(
+            ['bzrlib.tests.doc_generate.' + name
+             for name in testmod_names]))
+
+    return suite

=== added directory 'bzrlib/tests/doc_generate/builders'
=== added file 'bzrlib/tests/doc_generate/builders/__init__.py'
--- bzrlib/tests/doc_generate/builders/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/doc_generate/builders/__init__.py	2010-04-29 15:41:20 +0000
@@ -0,0 +1,33 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+
+"""Sphinx builders tests."""
+
+def load_tests(basic_tests, module, loader):
+    suite = loader.suiteClass()
+    # add the tests for this module
+    suite.addTests(basic_tests)
+
+    testmod_names = [
+        'texinfo',
+        ]
+    # add the tests for the sub modules
+    suite.addTests(loader.loadTestsFromModuleNames(
+            ['bzrlib.tests.doc_generate.builders.test_' + name
+             for name in testmod_names]))
+
+    return suite

=== added file 'bzrlib/tests/doc_generate/builders/test_texinfo.py'
--- bzrlib/tests/doc_generate/builders/test_texinfo.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/doc_generate/builders/test_texinfo.py	2010-04-29 15:41:20 +0000
@@ -0,0 +1,31 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""sphinx texinfo builder tests."""
+
+from bzrlib import tests
+from bzrlib.doc_generate import (
+    # FIXME: doc/en/conf.py should be used here, or rather merged into
+    # sphinx_conf and the later be renamed conf -- vila 20100429
+    sphinx_conf,
+    )
+
+
+class TestBuilderLoaded(tests.TestCase):
+
+    def test_builder_loaded(self):
+        self.assertTrue('bzrlib.doc_generate.builders.texinfo'
+                        in sphinx_conf.extensions)

=== removed file 'bzrlib/tests/matchers.py'
--- bzrlib/tests/matchers.py	2010-05-06 11:08:10 +0000
+++ bzrlib/tests/matchers.py	1970-01-01 00:00:00 +0000
@@ -1,68 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Matchers for bzrlib.
-
-Primarily test support, Matchers are used by self.assertThat in the bzrlib
-test suite. A matcher is a stateful test helper which can be used to determine
-if a passed object 'matches', much like a regex. If the object does not match
-the mismatch can be described in a human readable fashion. assertThat then
-raises if a mismatch occurs, showing the description as the assertion error.
-
-Matchers are designed to be more reusable and composable than layered
-assertions in Test Case objects, so they are recommended for new testing work.
-"""
-
-__all__ = [
-    'ReturnsUnlockable',
-    ]
-
-from testtools.matchers import Mismatch, Matcher
-
-
-class ReturnsUnlockable(Matcher):
-    """A matcher that checks for the pattern we want lock* methods to have:
-
-    They should return an object with an unlock() method.
-    Calling that method should unlock the original object.
-
-    :ivar lockable_thing: The object which can be locked that will be
-        inspected.
-    """
-
-    def __init__(self, lockable_thing):
-        Matcher.__init__(self)
-        self.lockable_thing = lockable_thing
-
-    def __str__(self):
-        return ('ReturnsUnlockable(lockable_thing=%s)' % 
-            self.lockable_thing)
-
-    def match(self, lock_method):
-        lock_method().unlock()
-        if self.lockable_thing.is_locked():
-            return _IsLocked(self.lockable_thing)
-        return None
-
-
-class _IsLocked(Mismatch):
-    """Something is locked."""
-
-    def __init__(self, lockable_thing):
-        self.lockable_thing = lockable_thing
-
-    def describe(self):
-        return "%s is locked" % self.lockable_thing

=== modified file 'bzrlib/tests/per_repository_chk/__init__.py'
--- bzrlib/tests/per_repository_chk/__init__.py	2010-03-31 16:29:25 +0000
+++ bzrlib/tests/per_repository_chk/__init__.py	2009-09-08 06:25:26 +0000
@@ -27,6 +27,7 @@
     repository,
     remote,
     )
+from bzrlib.bzrdir import BzrDir
 from bzrlib.repofmt.pack_repo import (
     RepositoryFormatKnitPack5,
     )
@@ -35,6 +36,7 @@
     )
 from bzrlib.tests import (
     multiply_tests,
+    TestSuite,
     )
 from bzrlib.tests.per_repository import (
     all_repository_format_scenarios,

=== modified file 'bzrlib/tests/per_repository_reference/test_default_stacking.py'
--- bzrlib/tests/per_repository_reference/test_default_stacking.py	2010-05-03 04:08:50 +0000
+++ bzrlib/tests/per_repository_reference/test_default_stacking.py	2010-04-26 13:51:08 +0000
@@ -15,10 +15,10 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
-from bzrlib.tests.per_repository import TestCaseWithRepository
-
-
-class TestDefaultStackingPolicy(TestCaseWithRepository):
+from bzrlib.tests import per_repository
+
+
+class TestDefaultStackingPolicy(per_repository.TestCaseWithRepository):
 
     def test_sprout_to_smart_server_stacking_policy_handling(self):
         """Obey policy where possible, ignore otherwise."""

=== removed file 'bzrlib/tests/test_matchers.py'
--- bzrlib/tests/test_matchers.py	2010-05-06 11:08:10 +0000
+++ bzrlib/tests/test_matchers.py	1970-01-01 00:00:00 +0000
@@ -1,64 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests of bzrlib test matchers."""
-
-from testtools.matchers import *
-
-from bzrlib.tests import TestCase
-from bzrlib.tests.matchers import *
-
-
-class StubTree(object):
-    """Stubg for testing."""
-
-    def __init__(self, lock_status):
-        self._is_locked = lock_status
-
-    def __str__(self):
-        return u'I am da tree'
-
-    def is_locked(self):
-        return self._is_locked
-
-
-class FakeUnlockable(object):
-    """Something that can be unlocked."""
-
-    def unlock(self):
-        pass
-
-
-class TestReturnsUnlockable(TestCase):
-
-    def test___str__(self):
-        matcher = ReturnsUnlockable(StubTree(True))
-        self.assertEqual(
-            'ReturnsUnlockable(lockable_thing=I am da tree)',
-            str(matcher))
-
-    def test_match(self):
-        stub_tree = StubTree(False)
-        matcher = ReturnsUnlockable(stub_tree)
-        self.assertThat(matcher.match(lambda:FakeUnlockable()), Equals(None))
-
-    def test_mismatch(self):
-        stub_tree = StubTree(True)
-        matcher = ReturnsUnlockable(stub_tree)
-        mismatch = matcher.match(lambda:FakeUnlockable())
-        self.assertNotEqual(None, mismatch)
-        self.assertThat(mismatch.describe(), Equals("I am da tree is locked"))
-

=== modified file 'bzrlib/tests/test_options.py'
--- bzrlib/tests/test_options.py	2010-04-20 08:47:38 +0000
+++ bzrlib/tests/test_options.py	2009-05-23 21:01:51 +0000
@@ -318,13 +318,6 @@
         self.assertEqual('hello', name)
         self.assertEqual([], value)
 
-    def test_list_option_param_name(self):
-        """Test list options can have their param_name set."""
-        options = [option.ListOption('hello', type=str, param_name='greeting')]
-        opts, args = self.parse(
-            options, ['--hello=world', '--hello=sailor'])
-        self.assertEqual(['world', 'sailor'], opts.greeting)
-
 
 class TestOptionDefinitions(TestCase):
     """Tests for options in the Bazaar codebase."""

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2010-05-03 04:08:50 +0000
+++ bzrlib/tests/test_remote.py	2010-04-20 00:20:00 +0000
@@ -418,12 +418,9 @@
         # Calling _remember_remote_is_before again with a lower value works.
         client_medium._remember_remote_is_before((1, 5))
         self.assertTrue(client_medium._is_remote_before((1, 5)))
-        # If you call _remember_remote_is_before with a higher value it logs a
-        # warning, and continues to remember the lower value.
-        self.assertNotContainsRe(self.get_log(), '_remember_remote_is_before')
-        client_medium._remember_remote_is_before((1, 9))
-        self.assertContainsRe(self.get_log(), '_remember_remote_is_before')
-        self.assertTrue(client_medium._is_remote_before((1, 5)))
+        # You cannot call _remember_remote_is_before with a larger value.
+        self.assertRaises(
+            AssertionError, client_medium._remember_remote_is_before, (1, 9))
 
 
 class TestBzrDirCloningMetaDir(TestRemote):
@@ -531,28 +528,6 @@
         self.assertIsInstance(bd, RemoteBzrDir)
         self.assertFinished(client)
 
-    def test_backwards_compat_hpss_v2(self):
-        client, transport = self.make_fake_client_and_transport()
-        # Monkey-patch fake client to simulate real-world behaviour with v2
-        # server: upon first RPC call detect the protocol version, and because
-        # the version is 2 also do _remember_remote_is_before((1, 6)) before
-        # continuing with the RPC.
-        orig_check_call = client._check_call
-        def check_call(method, args):
-            client._medium._protocol_version = 2
-            client._medium._remember_remote_is_before((1, 6))
-            client._check_call = orig_check_call
-            client._check_call(method, args)
-        client._check_call = check_call
-        client.add_expected_call(
-            'BzrDir.open_2.1', ('quack/',), 'unknown', ('BzrDir.open_2.1',))
-        client.add_expected_call(
-            'BzrDir.open', ('quack/',), 'success', ('yes',))
-        bd = RemoteBzrDir(transport, remote.RemoteBzrDirFormat(),
-            _client=client, _force_probe=True)
-        self.assertIsInstance(bd, RemoteBzrDir)
-        self.assertFinished(client)
-
 
 class TestBzrDirOpenBranch(TestRemote):
 

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2010-03-31 16:29:25 +0000
+++ bzrlib/tests/test_repository.py	2010-02-09 21:03:24 +0000
@@ -23,10 +23,12 @@
 """
 
 from stat import S_ISDIR
+from StringIO import StringIO
 import sys
 
 import bzrlib
-from bzrlib.errors import (NoSuchFile,
+from bzrlib.errors import (NotBranchError,
+                           NoSuchFile,
                            UnknownFormatError,
                            UnsupportedFormatError,
                            )
@@ -34,23 +36,31 @@
     graph,
     tests,
     )
+from bzrlib.branchbuilder import BranchBuilder
 from bzrlib.btree_index import BTreeBuilder, BTreeGraphIndex
-from bzrlib.index import GraphIndex
+from bzrlib.index import GraphIndex, InMemoryGraphIndex
 from bzrlib.repository import RepositoryFormat
+from bzrlib.smart import server
 from bzrlib.tests import (
     TestCase,
     TestCaseWithTransport,
+    TestSkipped,
+    test_knit,
     )
 from bzrlib.transport import (
+    fakenfs,
     get_transport,
     )
 from bzrlib import (
+    bencode,
     bzrdir,
     errors,
     inventory,
     osutils,
+    progress,
     repository,
     revision as _mod_revision,
+    symbol_versioning,
     upgrade,
     versionedfile,
     workingtree,

=== modified file 'bzrlib/textinv.py'
--- bzrlib/textinv.py	2010-04-30 11:03:59 +0000
+++ bzrlib/textinv.py	2009-03-23 14:59:43 +0000
@@ -16,7 +16,7 @@
 
 
 from bzrlib.errors import BzrError
-from bzrlib.inventory import Inventory
+from bzrlib.inventory import InventoryEntry, Inventory
 
 
 START_MARK = "# bzr inventory format 3\n"

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2010-04-30 11:35:43 +0000
+++ bzrlib/transform.py	2010-04-28 07:53:34 +0000
@@ -35,7 +35,7 @@
     )
 """)
 from bzrlib.errors import (DuplicateKey, MalformedTransform, NoSuchFile,
-                           ReusingTransform, CantMoveRoot,
+                           ReusingTransform, NotVersionedError, CantMoveRoot,
                            ExistingLimbo, ImmortalLimbo, NoFinalPath,
                            UnableCreateSymlink)
 from bzrlib.filters import filtered_output_bytes, ContentFilterContext

=== modified file 'bzrlib/transport/chroot.py'
--- bzrlib/transport/chroot.py	2010-04-07 12:19:40 +0000
+++ bzrlib/transport/chroot.py	2010-02-23 07:43:11 +0000
@@ -19,8 +19,12 @@
 """
 
 from bzrlib.transport import (
+    get_transport,
     pathfilter,
     register_transport,
+    Server,
+    Transport,
+    unregister_transport,
     )
 
 

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/tree.py	2010-02-17 05:12:01 +0000
@@ -36,6 +36,7 @@
 from bzrlib.inventory import InventoryFile
 from bzrlib.inter import InterObject
 from bzrlib.osutils import fingerprint_file
+import bzrlib.revision
 from bzrlib.symbol_versioning import deprecated_function, deprecated_in
 from bzrlib.trace import note
 

=== modified file 'bzrlib/uncommit.py'
--- bzrlib/uncommit.py	2010-04-30 11:03:59 +0000
+++ bzrlib/uncommit.py	2009-03-23 14:59:43 +0000
@@ -18,6 +18,8 @@
 
 # TODO: make the guts of this methods on tree, branch.
 
+import os
+
 from bzrlib import (
     errors,
     revision as _mod_revision,

=== modified file 'bzrlib/version.py'
--- bzrlib/version.py	2010-04-30 11:03:59 +0000
+++ bzrlib/version.py	2010-02-23 07:43:11 +0000
@@ -27,6 +27,7 @@
     osutils,
     trace,
     )
+from bzrlib.branch import Branch
 
 
 def show_version(show_config=True, show_copyright=True, to_file=None):

=== modified file 'bzrlib/versionedfile.py'
--- bzrlib/versionedfile.py	2010-04-30 11:03:59 +0000
+++ bzrlib/versionedfile.py	2010-02-17 17:11:16 +0000
@@ -45,6 +45,7 @@
 from bzrlib.graph import DictParentsProvider, Graph, StackedParentsProvider
 from bzrlib.transport.memory import MemoryTransport
 """)
+from bzrlib.inter import InterObject
 from bzrlib.registry import Registry
 from bzrlib.symbol_versioning import *
 from bzrlib.textmerge import TextMerge

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2010-04-30 11:03:59 +0000
+++ bzrlib/weave.py	2009-06-10 03:56:49 +0000
@@ -69,6 +69,8 @@
 from copy import copy
 from cStringIO import StringIO
 import os
+import time
+import warnings
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -77,11 +79,14 @@
 from bzrlib import (
     errors,
     osutils,
+    progress,
     )
 from bzrlib.errors import (WeaveError, WeaveFormatError, WeaveParentMismatch,
         RevisionAlreadyPresent,
         RevisionNotPresent,
         UnavailableRepresentation,
+        WeaveRevisionAlreadyPresent,
+        WeaveRevisionNotPresent,
         )
 from bzrlib.osutils import dirname, sha, sha_strings, split_lines
 import bzrlib.patiencediff

=== modified file 'bzrlib/win32utils.py'
--- bzrlib/win32utils.py	2010-04-30 11:03:59 +0000
+++ bzrlib/win32utils.py	2010-02-23 07:43:11 +0000
@@ -21,6 +21,7 @@
 
 import glob
 import os
+import re
 import struct
 import sys
 

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2010-04-30 11:35:43 +0000
+++ bzrlib/workingtree.py	2010-04-27 04:30:01 +0000
@@ -95,6 +95,7 @@
 from bzrlib.filters import filtered_input_file
 from bzrlib.trace import mutter, note
 from bzrlib.transport.local import LocalTransport
+from bzrlib.progress import ProgressPhase
 from bzrlib.revision import CURRENT_REVISION
 from bzrlib.rio import RioReader, rio_file, Stanza
 from bzrlib.symbol_versioning import (

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2010-04-30 11:03:59 +0000
+++ bzrlib/workingtree_4.py	2010-03-10 09:31:25 +0000
@@ -53,6 +53,7 @@
 from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.filters import filtered_input_file, internal_size_sha_file_byname
 from bzrlib.inventory import Inventory, ROOT_ID, entry_factory
+import bzrlib.mutabletree
 from bzrlib.mutabletree import needs_tree_write_lock
 from bzrlib.osutils import (
     file_kind,

=== modified file 'bzrlib/xml4.py'
--- bzrlib/xml4.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml4.py	2010-02-17 17:11:16 +0000
@@ -16,11 +16,12 @@
 
 from bzrlib.xml_serializer import (
     Element,
+    ElementTree,
     SubElement,
     XMLSerializer,
     escape_invalid_chars,
     )
-from bzrlib.inventory import ROOT_ID, Inventory
+from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 import bzrlib.inventory as inventory
 from bzrlib.revision import Revision
 from bzrlib.errors import BzrError

=== modified file 'bzrlib/xml8.py'
--- bzrlib/xml8.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml8.py	2010-02-17 17:11:16 +0000
@@ -30,7 +30,7 @@
     XMLSerializer,
     escape_invalid_chars,
     )
-from bzrlib.inventory import InventoryEntry
+from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 from bzrlib.revision import Revision
 from bzrlib.errors import BzrError
 

=== modified file 'bzrlib/xml_serializer.py'
--- bzrlib/xml_serializer.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml_serializer.py	2010-02-17 17:11:16 +0000
@@ -23,7 +23,7 @@
 # ElementTree bits
 
 from bzrlib.serializer import Serializer
-from bzrlib.trace import mutter
+from bzrlib.trace import mutter, warning
 
 try:
     try:

=== modified file 'doc/en/Makefile'
--- doc/en/Makefile	2010-03-25 10:09:32 +0000
+++ doc/en/Makefile	2010-04-28 16:52:07 +0000
@@ -11,22 +11,6 @@
 PAPEROPT_letter = -D latex_paper_size=letter
 ALLSPHINXOPTS   = -d _build/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
 
-# Note that this assumes name of the output dir is same as name of the rule.
-define make_output_dirs
-# Create output directory (only needed for sphinx < 0.5)
-[ -d _build ] || mkdir _build
-[ -d "_build/$@" ] || mkdir "_build/$@"
-# Workaround for a bug in sphinx < 0.5 where it tries to delete
-# nonexistent static dirs and does not catch the exception.  This was
-# fixed in svn+ssh://pythondev@svn.python.org/doctools/branches/0.4.x
-# at r65551 and merged as 280b62246342 in hg branch released as 0.5.
-[ -d "_build/$@/_static" ] || mkdir "_build/$@/_static"
-for fn in _static/*; do \
-    [ ! -d "$$fn" ] && continue; \
-    [ -d "_build/$@/$$fn" ] || mkdir "_build/$@/$$fn"; \
-done
-endef
-
 .PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest
 
 help:
@@ -46,38 +30,32 @@
 	-rm -rf _build/*
 
 html:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) _build/html
 	@echo
 	@echo "Build finished. The HTML pages are in _build/html."
 
 dirhtml:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) _build/dirhtml
 	@echo
 	@echo "Build finished. The HTML pages are in _build/dirhtml."
 
 pickle:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) _build/pickle
 	@echo
 	@echo "Build finished; now you can process the pickle files."
 
 json:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) _build/json
 	@echo
 	@echo "Build finished; now you can process the JSON files."
 
 htmlhelp:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) _build/htmlhelp
 	@echo
 	@echo "Build finished; now you can run HTML Help Workshop with the" \
 	      ".hhp project file in _build/htmlhelp."
 
 qthelp:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) _build/qthelp
 	@echo
 	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
@@ -87,7 +65,6 @@
 	@echo "# assistant -collectionFile _build/qthelp/Bazaar.qhc"
 
 latex:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) _build/latex
 	@echo
 	@echo "Build finished; the LaTeX files are in _build/latex."
@@ -95,20 +72,21 @@
 	      "run these through (pdf)latex."
 
 changes:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) _build/changes
 	@echo
 	@echo "The overview file is in _build/changes."
 
 linkcheck:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) _build/linkcheck
 	@echo
 	@echo "Link check complete; look for any errors in the above output " \
 	      "or in _build/linkcheck/output.txt."
 
 doctest:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) _build/doctest
 	@echo "Testing of doctests in the sources finished, look at the " \
 	      "results in _build/doctest/output.txt."
+
+texinfo:
+	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) _build/texinfo
+

=== modified file 'doc/en/conf.py'
--- doc/en/conf.py	2010-03-03 04:18:28 +0000
+++ doc/en/conf.py	2010-04-29 15:41:20 +0000
@@ -15,7 +15,6 @@
 # Most of the configuration for Bazaar docs is defined here ...
 from bzrlib.doc_generate.sphinx_conf import *
 
-
 ## Configuration specific to this site ##
 
 # The locale code for this documentation set

